unit ExeMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TMainForm = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    BtnInstall: TBitBtn;
    BtnUnInstall: TBitBtn;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BtnInstallClick(Sender: TObject);
    procedure BtnUnInstallClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    WndProc: TWndMethod;
    procedure CustomWndProc(var Msg: TMessage);
    procedure HookedCBTProc(const Msg: TMessage);
    procedure HookedMouseProc(const Msg: TMessage);
    procedure MessageOut(AMsg: string; const Msg: TMessage);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    ExeInfo;

const
    HOOK_DLL_NAME = 'PasteItHook.dll';

//-----------------------------------------------------------------------------
//  DLLC|[gEăX^eBbNN
function HookInstall(Wnd: HWND): Boolean; stdcall;external HOOK_DLL_NAME;
procedure  HookUnInstall(); stdcall;external HOOK_DLL_NAME;

//-----------------------------------------------------------------------------
//  bZ[W\
procedure TMainForm.MessageOut(AMsg: string; const Msg: TMessage);
var
    NowStr: string;
    FmtStr: string;
begin
    NowStr := FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);
    FmtStr := Format('%s %s lParam:%d,wParam:%d', [NowStr, AMsg, Msg.lParam, Msg.wParam]);
    Memo1.Lines.Add(FmtStr);

    //  http://forum.nifty.com/fdelphi/samples/00782.html
    //  I̎dg
    if (GetAsyncKeyState(VK_ESCAPE)) <> 0 then BtnUnInstallClick(BtnUnInstall);
end;

//-----------------------------------------------------------------------------
//  CXg[
procedure TMainForm.BtnInstallClick(Sender: TObject);
begin
    HookUnInstall();
    HookInstall(Self.Handle);
end;

//-----------------------------------------------------------------------------
//  ACXg[
procedure TMainForm.BtnUnInstallClick(Sender: TObject);
begin
    HookUnInstall();
end;

//-----------------------------------------------------------------------------
//  tH[RXgN^
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  EBhEvV[WobNAbv
    WndProc := Self.WindowProc;
    //  ւ
    Self.WindowProc := CustomWndProc;
end;

//-----------------------------------------------------------------------------
//  tH[fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  Ô߃ACXg[
    HookUnInstall();
    //  łEBhEvV[W߂
    Self.WindowProc := WndProc;
end;

//-----------------------------------------------------------------------------
//  o[W
procedure TMainForm.Button1Click(Sender: TObject);
begin
    ShowInfoForm();
end;

//-----------------------------------------------------------------------------
//  ւpEBhEvV[W
procedure TMainForm.CustomWndProc(var Msg: TMessage);
begin
    case Msg.Msg - WM_APP of

    //  CBTProc
    HCBT_ACTIVATE,
    HCBT_CLICKSKIPPED,
    HCBT_CREATEWND,
    HCBT_DESTROYWND,
    HCBT_KEYSKIPPED,
    HCBT_MINMAX,
    HCBT_MOVESIZE,
    HCBT_QS,
    HCBT_SETFOCUS,
    HCBT_SYSCOMMAND:
        HookedCBTProc(Msg);

    //  MouseProc
    WM_APP + HC_ACTION,
    WM_APP + HC_NOREMOVE:
        HookedMouseProc(Msg);

    end;

    //  낤Ƃ͌ĂԁB
    WndProc(Msg);
end;

//-----------------------------------------------------------------------------
//  HookedCBTProc mF
procedure TMainForm.HookedCBTProc(const Msg: TMessage);
begin
    case Msg.Msg - WM_APP * 1 of
        HCBT_ACTIVATE:      MessageOut('HCBT_ACTIVATE', Msg);
        HCBT_CLICKSKIPPED:  MessageOut('HCBT_CLICKSKIPPED', Msg);
        HCBT_CREATEWND:     MessageOut('HCBT_CREATEWND', Msg);
        HCBT_DESTROYWND:    MessageOut('HCBT_DESTROYWND', Msg);
        HCBT_KEYSKIPPED:    MessageOut('HCBT_KEYSKIPPED', Msg);
        HCBT_MINMAX:        MessageOut('HCBT_MINMAX', Msg);
        HCBT_MOVESIZE:      MessageOut('HCBT_MOVESIZE', Msg);
        HCBT_QS:            MessageOut('HCBT_QS', Msg);
        HCBT_SETFOCUS:      MessageOut('HCBT_SETFOCUS', Msg);
        HCBT_SYSCOMMAND:    MessageOut('HCBT_SYSCOMMAND', Msg);
    end;
end;

//-----------------------------------------------------------------------------
//  HookedMouseProc mF@
procedure TMainForm.HookedMouseProc(const Msg: TMessage);
begin
    case Msg.Msg - WM_APP * 2 of
        HC_ACTION:      MessageOut('HC_ACTION', Msg);
        HC_NOREMOVE:    MessageOut('HC_NOREMOVE', Msg);
    end;
end;

end.

